//------------------------------------------------------------------------
// GraphWaves Applet
// This applet draws one kind of sound waves and makes it possible to
// adjust graph's phase, amplitude and frequency. If user clicks on the
// 'Play' button, it will generate 1 second length 8 bit 8000Hz sampling
//  mu-law sound.
//
// INPUT:  HTML parameter of graph kind and user mouse clicking
//
// OUTPUT: graph and 1 second length 8-bit mu-law audio sound.
//
// @author Jungkee Kim
// @version 1.0S, May 1997

import java.applet.*;
import java.awt.*; 
import java.lang.Math; 
import java.util.*;

public class GraphWaves extends java.applet.Applet {
  GraphDraw           soundgraph;              // sound graph
  PlayControlPanel    control;                 // control panel
  String              wave;                    // kind of waves

  public void init() {
    wave = getParameter("wave");
    if (wave == null)                          // if no parameter passed
      wave = "Rectangular";
    setLayout(new BorderLayout(2, 2));
    control = new PlayControlPanel(this);
    soundgraph = new GraphDraw(this);
    add("North", control);
    add("Center", soundgraph);
    if (wave.equals("Sine")) soundgraph.setSine();
    else if (wave.equals("Rectangular")) soundgraph.setRectangular();
    else if (wave.equals("Triangle")) soundgraph.setTriangle();
    control.setBackground(new Color(0xFFEBCD));
  }
}

/* This panel draws play button panel and generates sound when clicking */
class PlayControlPanel extends Panel {
  GraphWaves parent;

  PlayControlPanel(GraphWaves parent) {
    this.parent = parent;
    setLayout(new BorderLayout());
    add("Center", new Button("Play"));
  }

  public boolean action(Event evt, Object arg) {
    if (evt.target instanceof Button) {
      getWave((String)arg);
      return true;
    }
    else return false;
  }

  void getWave(String cname) {
    if (cname.equals("Play")) {
      PlaySound();
    }
  }

  void PlaySound() {
    SecondSound stream = new SecondSound(this);
    stream.run();
  }
}
